﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace TrabalhoLP
{
    class Escrita
    {
        public Escrita(){}

        public void gerarRelatorios(Revista rev)
        {
            escreverResumo(rev);
            escreverRevisoes(rev);
            escreverRevisores(rev);
        }

        public void escreverResumo(Revista rev)
        {
            HashSet<int> aux = new HashSet<int>();
            using (StreamWriter writer = new StreamWriter(@"relat-resumo.txt"))
            {     
                int a,b;
                DateTime dt;
	            a = rev.getEdicao().getNumero();
	            b = rev.getEdicao().getVolume();
                dt = rev.getEdicao().getDtPublicacao();

                writer.WriteLine("EngeSoft, num. " + a + ", volume "+ b+ " - " + dataResumo(dt.Month)+ " de "+ dt.Year);
                writer.WriteLine("Tema: "+rev.getEdicao().getNomeTema());
                writer.WriteLine("Editor-chefe: " + rev.getEdicao().getNomeEditorChefe());
                writer.WriteLine("\n");

                writer.WriteLine("Artigos submetidos: " + rev.getArtigos().Count);
                writer.WriteLine("Revisores capacitados: " + rev.getEdicao().getTema().getCodigosRevisores().Count);

                foreach(Revisao r in rev.getRevisoes())
                    aux.Add(r.getRevisor().getCodigo());

                writer.WriteLine("Revisores envolvidos: " + aux.Count);
                double d1, media;
                d1 = rev.getRevisoes().Count;
                media = d1/aux.Count;
                writer.WriteLine("Média artigos/revisor: " + Math.Round (media,2));
                
            }
        }

       public string dataResumo(int mes) 
       {
	    string[] months = {"Janeiro", "Fevereiro","Março", "Abril", "Maio", "Junho","Julho","Agosto","Setembro", "Outubro", "Novembro", "Dezembro"};

	    return months[mes-1];
       }

       public void escreverRevisoes(Revista rev)
       {               
           using (StreamWriter writer = new StreamWriter(@"relat-revisoes.csv"))
           {
               writer.WriteLine("Artigo;Autor de contato;Média das avaliações;Revisor 1; Revisor 2; Revisor 3");

               List<Artigo> art = new List<Artigo>();

               foreach (KeyValuePair<int, Artigo> ar in rev.getArtigos())
                   art.Add(ar.Value);

               art.Sort(new ArtigoComparer());
               foreach (Artigo artigo in art)
               {
                   writer.Write(artigo.getTitulo() + ";" + artigo.getAutorContato().getNome() + ";" +Math.Round(artigo.getMediaRevisoes(),2));


                   artigo.getRevisoes().Sort(new RevisaoComparer());
                   foreach (Revisao r in artigo.getRevisoes())
                       writer.Write(";" + r.getRevisor().getNome());

                   writer.Write("\n");
                }



           }

       }

       public void escreverRevisores(Revista rev)
       {
           List<Revisor> r = new List<Revisor>();
           foreach (KeyValuePair<int, Revisor> re in rev.getRevisores())
               r.Add(re.Value);
           using (StreamWriter writer = new StreamWriter(@"relat-revisores.csv"))
           {
               writer.Write("Revisor;Qtd. artigos revisados;Média das notas atribuídas\n");

               r.Sort(new RevisorComparer());

               foreach (Revisor revi in r)
               {   
                   if(revi.getRevisoes().Count != 0)
                        writer.Write(revi.getNome() + ";" + revi.getRevisoes().Count + ";" + Math.Round(revi.getMediaRevisoes(), 2) + "\n");
               }

           }
       }
    }
}
