﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace TrabalhoLP
{
    class Leitor
    {
        string input;
        string[] words;

        public void lerRevista(Revista rev, string[] args)
        {
            int i;
            string[] aux = new string[args.Count()];             

            for (i = 0; i < args.Count() - 1; i += 2)
            {
                if (args[i].Equals("-p") )
                {
                    aux[0] = args[i];
                    aux[1] = args[i + 1];                    
                }
                if (args[i].Equals("-t"))
                {
                    aux[2] = args[i];
                    aux[3] = args[i + 1];
                }
                if (args[i].Equals("-e"))
                {
                    aux[4] = args[i];
                    aux[5] = args[i + 1];
                }
                if (args[i].Equals("-a"))
                {
                    aux[6] = args[i];
                    aux[7] = args[i + 1];
                }
                if (args[i].Equals("-r"))
                {
                    aux[8] = args[i];
                    aux[9] = args[i + 1];
                }

            } 

            for (i = 0; i < args.Count() - 1; i += 2)
            {
                switch (aux[i])
                {
                    case "-e":
                        lerEdicao(rev,aux[i+1]);
                        break;

                    case "-t":
                        lerTema(rev,aux[i+1]);
                        break;

                    case "-p":
                        lerPessoa(rev,aux[i+1]);
                        break;

                    case "-a":
                        lerArtigo(rev,aux[i+1]);
                        break;

                    case "-r":
                        lerRevisao(rev,aux[i+1]);  						
                        break;

                }
            }


        }

        public void lerPessoa(Revista rev, string entrada)
        {
            using (StreamReader reader = new StreamReader(entrada))
            {
              reader.ReadLine();             
              while ((input = reader.ReadLine()) != null)
              {
                  words = input.Split(';');

                  Autor a;
                  Revisor r;
                  
                  switch (words[6])
                  {
                      case "A":
                          a = new Autor();
                          a.setCodigo(Convert.ToInt32(words[0]));
                          a.setNome(words[1]);
                          a.setEmail(words[2]);
                          a.setSenha(words[3]);
                          a.setInstituicao(words[4]);
                          a.setEndereco(words[5]);
                          a.setTipo(words[6]);
                          rev.addAutor(a.getCodigo(), a);                          
                          break;
                      case "R":
                          r = new Revisor();
                          r.setCodigo(Convert.ToInt32(words[0]));
                          r.setNome(words[1]);
                          r.setEmail(words[2]);
                          r.setSenha(words[3]);
                          r.setInstituicao(words[4]);
                          r.setEndereco(words[5]);
                          r.setTipo(words[6]);
                          rev.addRevisor(r.getCodigo(), r);                           
                          break;

                  }
              }
            }
            

        }

        public void lerTema(Revista rev, string entrada)
        {
            using (StreamReader reader = new StreamReader(entrada))
            {            
                reader.ReadLine();               
                while ((input = reader.ReadLine()) != null)
                {
                    words = input.Split(';');

                    Tema t = new Tema();

                    t.setCodigo(Convert.ToInt32( words[0] ));
                    t.setNome(words[1]);

                    string[] cods = words[2].Split(',');

                    foreach (string cod in cods)
                        t.addCodigosRevisores(Convert.ToInt32(cod));

                    rev.addTema(t.getNome(), t);
                    
                }  
            } 

        }

        public void lerEdicao(Revista rev, string entrada)
        {
            using (StreamReader reader = new StreamReader(entrada))
            {                     
                Edicao e = new Edicao();

                e.setNomeTema(reader.ReadLine());
                e.setNomeEditorChefe(reader.ReadLine());
                e.setVolume(Convert.ToInt32( reader.ReadLine()));
                e.setNumero(Convert.ToInt32(reader.ReadLine()));

                string[] date = reader.ReadLine().Split('/');
                DateTime dt = new DateTime(Convert.ToInt32(date[2]), Convert.ToInt32(date[1]), Convert.ToInt32(date[0]));

                e.setDtPublicacao(dt);

                try
                {
                    e.setTema(rev.getTemas()[e.getNomeTema()]);
                }
                catch (KeyNotFoundException)
                {
                    Console.WriteLine("Tema "+ e.getNomeTema() + " não cadastrado na Revista.");
                }
                rev.setEdicao(e);
                
            }
                

        }

        public void lerArtigo(Revista rev, string entrada)
        {
            using (StreamReader reader = new StreamReader(entrada))
            {
                reader.ReadLine();
                while ((input = reader.ReadLine()) != null)
                {
                    Artigo a = new Artigo();
                    words = input.Split(';');

                    a.setCodigo(Convert.ToInt32(words[0]));
                    a.setTitulo(words[1]);

                    string[] cods = words[2].Split(',');

                    foreach (string cod in cods)
                        a.addCodigoAutor(Convert.ToInt32(cod));

                    if (a.getCodigosAutores().Count > 1)
                    {
                        try
                        {
                            a.setAutorContato(rev.getAutores()[Convert.ToInt32(words[3])]);
                            a.setCodigoAutorContato(Convert.ToInt32(words[3]));

                        }
                        catch (KeyNotFoundException)
                        {
                            Console.WriteLine("O autor contato com o código " + words[3] + " do " + a.getTitulo() + " não esta cadastrado na Revista.");
                        }

                    }
                    else
                        a.setAutorContato(rev.getAutores()[Convert.ToInt32(words[2])]);
                   
                        
                    rev.addArtigo(a.getCodigo(), a);
                }
            }
        }
        public void lerRevisao(Revista rev, string entrada)
        {
            using (StreamReader reader = new StreamReader(entrada))
            {
                reader.ReadLine();
                while ((input = reader.ReadLine()) != null)
                {
                    Revisao r = new Revisao();

                    words = input.Split(';');
                    r.setCodigoArtigo( Convert.ToInt32 (words[0]));                    
                    r.setNotaOriginalidade(Convert.ToDouble(words[2]));
                    r.setNotaConteudo(Convert.ToDouble(words[3]));
                    r.setNotaApresentacao(Convert.ToDouble(words[4]));               

                    try
                    {
                        rev.getArtigos()[r.getCodigoArtigo()].addRevisao(r);
                        r.setRevisor( rev.getRevisores()[Convert.ToInt32(words[1])]);
                        rev.getRevisores()[r.getRevisor().getCodigo()].addRevisao(r);
                    }
                    catch (KeyNotFoundException)
                    {
                        Console.WriteLine("O Artigo com código " + r.getCodigoArtigo() + " de uma Revisão não esta cadastrado na Revista.");
                    }
                    rev.addRevisao(r);

                }
            }
        }

    }
}
