﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TrabalhoLP
{
    class Revista
    {
        string nome;
        Edicao edicao;
        SortedDictionary<int, Autor> autores;
        SortedDictionary<int, Revisor> revisores;
        SortedDictionary<string, Tema> temas;
        SortedDictionary<int, Artigo> artigos;
        List<Revisao> revisoes;


        public Revista(string nome)
        {
            this.nome = nome;
            autores = new SortedDictionary<int, Autor>() ;
            revisores = new SortedDictionary<int, Revisor>();
            temas = new SortedDictionary<string, Tema>();
            artigos = new SortedDictionary<int, Artigo>();
            revisoes = new List<Revisao>();
        }

        public SortedDictionary<int, Revisor> getRevisores()
        {
            return revisores;
        }


        public List<Revisao> getRevisoes()
        {
            return revisoes;
        }


        public SortedDictionary<int, Artigo> getArtigos()
        {
            return artigos;
        }

        public void addAutor(int cod, Autor a)
        {
            autores.Add(cod, a);
        }

        public void addRevisor(int cod, Revisor r)
        {
            revisores.Add(cod, r);
        }

        public void addTema(string nome, Tema t)
        {
            temas.Add(nome, t);
        }

        public void addArtigo(int cod, Artigo a)
        {
            artigos.Add(cod, a);
        }


        public void addRevisao(Revisao r)
        {
            revisoes.Add(r);
        }


        public string getNome()
        {
            return nome;
        }

        public void setNome(string nome)
        {
            this.nome = nome;
        }

        public Edicao getEdicao()
        {
            return edicao;
        }

        public void setEdicao(Edicao edicao)
        {
            this.edicao = edicao;
        }
        public SortedDictionary<int, Autor> getAutores()
        {
            return autores;
        }
        public SortedDictionary<string, Tema> getTemas()
        {
            return temas;
        }

    }
}
